var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { BigNumber } from "@ethersproject/bignumber";
import { parseUnits } from "@ethersproject/units";
export class BaseToken {
    constructor(args) {
        var _a, _b;
        this.addresses = {};
        this.wrapperAddresses = {};
        this._decimals = {};
        this.name = args.name;
        this.symbol = args.symbol;
        this.addresses = args.addresses;
        this.swapType = args.swapType;
        this.wrapperAddresses = (_a = args.wrapperAddresses) !== null && _a !== void 0 ? _a : {};
        if (typeof args.decimals === "number") {
            for (const [k,] of Object.entries(this.addresses)) {
                this._decimals[k] = args.decimals;
            }
        }
        else {
            this._decimals = args.decimals;
        }
        this.isETH = (_b = args.isETH) !== null && _b !== void 0 ? _b : false;
        this.hash = Buffer.from(this.symbol).toString("base64");
    }
    address(chainId) {
        return this.addresses[chainId] || null;
    }
    wrapperAddress(chainId) {
        return this.wrapperAddresses[chainId] || null;
    }
    decimals(chainId) {
        return this._decimals[chainId] || null;
    }
    isEqual(other) {
        return this.hash === other.hash;
    }
    valueToWei(amt, chainId) {
        let amtStr = BigNumber.from(amt).toString();
        return parseUnits(amtStr, this.decimals(chainId));
    }
    get isWrappedToken() {
        return false;
    }
}
export class WrappedToken extends BaseToken {
    constructor(args) {
        let { underlyingToken } = args, tokenArgs = __rest(args, ["underlyingToken"]);
        super(tokenArgs);
        this.underlyingToken = underlyingToken;
    }
    get isWrappedToken() {
        return true;
    }
}
